﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace TechNote67_FileDialog_CS
{
    public partial class FileDialogEx : Form
    {
        public FileDialogEx()
        {
            InitializeComponent();
        }

        private SmartX.SmartFile.SEARCHFILEINFOS retSelectFileInfo;

        public SmartX.SmartFile.SEARCHFILEINFOS SelectFileInfo
        {
            get
            {
                return retSelectFileInfo;
            }
        }

        private void FileDialogEx_Load(object sender, EventArgs e)
        {
            smartGroupBox1.Visible = false;
        }

        private void lstFileList_DoubleClick(object sender, EventArgs e)
        {
            if (lstFileList.SelectItemIndex != -1)
            {
                string[] path = lstFileList.Items[lstFileList.SelectItemIndex].Split(':');
                labFileName.Text = Path.GetFileNameWithoutExtension(path[0]);
                labFileExtension.Text = Path.GetExtension(path[0]);

                // 파일 확장자를 넘김
                retSelectFileInfo.strFileExtension = labFileExtension.Text;
                // 파일 이름을 넘김
                retSelectFileInfo.strFileName = labFileName.Text;
                // 파일 경로를 넘김
                retSelectFileInfo.strPath = path[0];
            }
        }

        // 검색어 입력을 가능하게 하는 SmartKeyboard 표시
        private void labSearchWord_Click(object sender, EventArgs e)
        {
            smartGroupBox1.Location = new Point(13, 38);

            smartGroupBox1.Visible = true;

            smartKeyboard1.Show();
            smartKeyboard1.TargetInputObject = labSearch;
        }

        // GroupBox의 검색어를 검색어 입력창에 표시.
        private void btnCompletion_Click(object sender, EventArgs e)
        {
            labSearchWord.Text = labSearch.Text;
            smartGroupBox1.Visible = false;
        }

        // 검색 버튼 클릭
        private void btnFind_Click(object sender, EventArgs e)
        {
            string strTemp;

            // 장치 선택
            if (radFlashDisk.Checked == true)
            {
                strTemp = "Flash Disk";
            }
            else if (radUSB.Checked == true)
            {
                strTemp = "하드 디스크";
            }
            else
            {
                strTemp = "SD Card";
            }

            // 현재 경로의 파일 리스트를 얻습니다.
            DeviceSelect(strTemp, labSearchWord.Text);
        }

        // 장치 목록 출력
        private void DeviceSelect(string temp1, string temp2)
        {
            // 리스트 항목 모두 삭제
            lstFileList.ClearAll();

            if (temp2 == "")
            {
                temp2 = "*.*";
            }

            SmartX.SmartFile.SEARCHFILEINFOS[] aFoundFileList = SmartX.SmartFile.FileSearch(temp1, temp2, true);
            for (int i = 0; i < aFoundFileList.Length; i++)
            {
                lstFileList.AddItem(aFoundFileList[i].strPath + "\\" + aFoundFileList[i].strFileName + "." + aFoundFileList[i].strFileExtension);
            }
        }

        // 검색창 종료
        private void btnClose_Click(object sender, EventArgs e)
        {
            this.DialogResult = DialogResult.OK;
            Close();
        }
    }
}