﻿Public Class FileDialogEx

    Private retSelectFileInfo As SmartX.SmartFile.SEARCHFILEINFOS

    Public ReadOnly Property SelectFileInfo() As SmartX.SmartFile.SEARCHFILEINFOS
        Get
            Return retSelectFileInfo
        End Get
    End Property

    Private Sub FileDialogEx_Load(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Load
        smartGroupBox1.Visible = False
    End Sub

    Private Sub lstFileList_DoubleClick(ByVal sender As Object, ByVal e As EventArgs) Handles lstFileList.DoubleClick
        If lstFileList.SelectItemIndex <> -1 Then
            Dim path As String() = lstFileList.Items(lstFileList.SelectItemIndex).Split(":"c)
            labFileName.Text = System.IO.Path.GetFileNameWithoutExtension(path(0))
            labFileExtension.Text = System.IO.Path.GetExtension(path(0))

            ' 파일 확장자를 넘김
            retSelectFileInfo.strFileExtension = labFileExtension.Text
            ' 파일 이름을 넘김
            retSelectFileInfo.strFileName = labFileName.Text
            ' 파일 경로를 넘김
            retSelectFileInfo.strPath = path(0)
        End If
    End Sub

    ' 검색어 입력을 가능하게 하는 SmartKeyboard 표시
    Private Sub labSearchWord_Click(ByVal sender As Object, ByVal e As EventArgs) Handles labSearchWord.Click
        smartGroupBox1.Location = New Point(13, 38)
        smartGroupBox1.Visible = True
        smartKeyboard1.Show()
        smartKeyboard1.TargetInputObject = labSearch
    End Sub

    ' GroupBox의 검색어를 검색어 입력창에 표시.
    Private Sub btnCompletion_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnCompletion.Click
        labSearchWord.Text = labSearch.Text
        smartGroupBox1.Visible = False
    End Sub

    ' 검색 버튼 클릭
    Private Sub btnFind_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnFind.Click
        Dim strTemp As String

        ' 장치 선택
        If radFlashDisk.Checked = True Then
            strTemp = "Flash Disk"
        ElseIf radUSB.Checked = True Then
            strTemp = "하드 디스크"
        Else
            strTemp = "SD Card"
        End If

        ' 현재 경로의 파일 리스트를 얻습니다.
        DeviceSelect(strTemp, labSearchWord.Text)
    End Sub

    ' 장치 목록 출력
    Private Sub DeviceSelect(ByVal temp1 As String, ByVal temp2 As String)
        ' 리스트 항목 모두 삭제
        lstFileList.ClearAll()

        If temp2 = "" Then
            temp2 = "*.*"
        End If

        Dim aFoundFileList As SmartX.SmartFile.SEARCHFILEINFOS() = SmartX.SmartFile.FileSearch(temp1, temp2, True)

        For i As Integer = 0 To aFoundFileList.Length - 1
            lstFileList.AddItem(aFoundFileList(i).strPath & "\" + aFoundFileList(i).strFileName & "." + aFoundFileList(i).strFileExtension)
        Next
    End Sub

    ' 검색창 종료
    Private Sub btnClose_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnClose.Click
        Me.DialogResult = DialogResult.OK
        Close()
    End Sub
End Class